#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;

    cin>>t;
    int n,k;
    cin>>n>>k;
    int n1=0;
    int p=0;
    vector<int>v(n);

    for(int i=0;i<n;i++){
       cin>>v[i];
       if(v[i]==-1){
        n1++;
       }
       else if(v[i]==1){
        p++;
       }
}
sort(v.begin(),v.end());

if(n1+p==n){
    if(k>3 & k<-3){
        cout<<"NE"<<endl;
        return 0;
    }
    else if(k==-2){
        if((n1-p)%2==0){
            cout<<"DA"<<endl;
            //naopacke
           if(t==1){
            for(int i=n-1;i>0;i--){
                cout<<v[i]+" ";
            }}
            cout<<""<<endl;
            return 0;
        }
        else{cout<<"NE"<<endl;return 0;}
    }
    else if(k==-1){
        if((n1-p)%2==1){
            cout<<"DA"<<endl;
            //naopacke
           if(t==1){
            for(int i=n-1;i>0;i--){
                cout<<v[i];
                cout<<" ";
            }}
            cout<<""<<endl;
            return 0;
        }
        else{cout<<"NE"<<endl;return 0;}
    }
    else if(k==0){
        if(n1==p){
            cout<<"DA"<<endl;
            if(t==1){
            for(int i=0;i<n;i++){
                if(i%2==0){
                    cout<<"-1 ";
                }
                else{
                    cout<<"1 ";
                }
            }}
            cout<<""<<endl;
            return 0;
        }
        else{cout<<"NE"<<endl;return 0;}
    }
    else if(k==1){
        if(p>0 &((n1%2==1 & p%2==0)|| (n1%2==0 & p%2==1))){
            cout<<"DA"<<endl;

            if(t==1){
            for(int i=0;i<n;i++){
                cout<<v[i];
                cout<<" "<<endl;
            }}
            cout<<" "<<endl;
            return 0;
        }
        else{
            cout<<"NE"<<endl;
            return 0;
        }
    }

    else{
        if(p>0 &((n1%2==1 & p%2==1)|| (n1%2==0 & p%2==0))){

        cout<<"DA"<<endl;

            if(t==1){
            for(int i=0;i<n;i++){
                cout<<v[i];
                cout<<" ";
            }}
            cout<<" "<<endl;
            return 0;
        }
        else{
            cout<<"NE"<<endl;
            return 0;
        }
    }

}
/*

int kp=0;
    for(int i=0;i<n;i++){
        if(kp<=v[i]){
            kp++;
        }
        else{
            kp--;
        }
    }
    if(kp==k){
        cout<<"DA"<<endl;
        if(t==1){
        for(int i=0;i<n;i++){
            cout<<v[i]<<endl;
        }}
    }
    else{cout<<"NE"<<endl;}
*/
}